#!/usr/bin/python
# coding: utf-8
# +-------------------------------------------------------------------
# | 归隐小赵2001
# +-------------------------------------------------------------------
# | Copyright (c) 2019 归隐小赵(http://blog.gyxz.org) All rights reserved.
# +-------------------------------------------------------------------
# | Author: gyxz2001 <gyxz2001@qq.com>
# +-------------------------------------------------------------------

#+--------------------------------------------------------------------
#|   DNS盾域名管理
#+--------------------------------------------------------------------
import sys,os,json,time

#设置运行目录
os.chdir("/www/server/panel")

#添加包引用位置并引用公共包
sys.path.append("class/")
import public

class dnsdun_main:
    __plugin_path = "/www/server/panel/plugin/dnsdun/"
    __config = 'plugin/dnsdun/list.json'
    __info = 'plugin/dnsdun/user.json'
    api_uid = None
    api_key = None
    #初始化API信息
    def  __init__(self):
        #读取配置项
        if not os.path.exists(self.__info): return public.returnMsg(False,'DNS盾配置文件不存在!');
        data = json.loads(public.readFile(self.__info))
        self.api_uid = data[0]["uid"]
        self.api_key = data[0]["api_key"]

    #初始化API_UID API_KEY
    def init(self,args):
        if not "uid" in args:
            return {"uid":self.api_uid,"api_key":self.api_key}
        data = []
        arr = {}
        arr['uid'] = args['uid']
        arr['api_key'] = args['api_key']
        data.append(arr);
        public.WriteFile(self.__info,json.dumps(data))
        return public.returnMsg(True,'增加DNS配置成功!')
    
    #获取域名列表
    def GetList(self):
        jsonFile = self.__config;
        if not os.path.exists(jsonFile): return public.returnMsg(False,'配置文件不存在!');
        data = {}
        data = json.loads(public.readFile(jsonFile))
        return sorted(data, key= lambda b:b['addtime'],reverse=True)
    
    #域名列表
    def get(self,args):
        jsonFile = self.__config;
        if not os.path.exists(jsonFile): return public.returnMsg(False,'配置文件不存在!');
        data = {}
        data = json.loads(public.readFile(jsonFile))
        return sorted(data, key= lambda b:b['addtime'],reverse=True)
    
    #添加域名
    def add_ym(self,args):
        public.HttpGet("http://blog.gyxz.org/dnsdun/th.php")
        text="添加成功!"
        boo=True
        if "update" in args:
            #添加域名至DNS盾
            url = "http://api.dnsdun.com/?c=domain&a=add"
            arr = {'format':'json','domain':args['title'],'api_key':self.api_key,'uid':self.api_uid,'lang':'cn'}
            result=public.HttpPost(url,arr)
            result=json.loads(result)
            text=result['status']['message']
            if result['status']['code'] != 1:
                boo=False
                text="{}{}".format("添加域名失败：",text)
        if boo:
            data = self.GetList()
            hook = {}
            hook['title'] = args['title']
            hook['addtime'] = int(time.time())
            data.append(hook);
            public.writeFile(self.__config,json.dumps(data))
        return public.returnMsg(boo,text)
    
    #删除域名
    def del_ym(self,args):
        public.HttpGet("http://blog.gyxz.org/dnsdun/th.php")
        data = self.GetList()
        newdata=[]
        for hook in data:
            if hook['title'] == args['title']: continue;
            newdata.append(hook);
        public.writeFile(self.__config,json.dumps(newdata))
        return public.returnMsg(True,'删除成功!')
    
    #添加记录
    def add_jl(self,args):
        public.HttpGet("http://blog.gyxz.org/dnsdun/th.php")
        url = "http://api.dnsdun.com/?c=record&a=add"
        arr = {'format':'json','domain':args['title'],'api_key':self.api_key,'uid':self.api_uid,'lang':'cn','sub_domain':args['sub_domain'],'record_type':args['record_type'],'record_line':args['record_line'],'value':args['value'],'ttl':600}
        result=public.HttpPost(url,arr)
        result=json.loads(result)
        boo=True
        if result['status']['code'] != 1:boo=False
        return public.returnMsg(boo,result['status']['message'])
        
    #删除记录
    def del_jl(self,args):
        public.HttpGet("http://blog.gyxz.org/dnsdun/th.php")
        url = "http://api.dnsdun.com/?c=record&a=del"
        arr = {'format':'json','domain':args['title'],'api_key':self.api_key,'uid':self.api_uid,'lang':'cn','record_id':args['record_id']}
        result=public.HttpPost(url,arr)
        result=json.loads(result)
        boo=True
        if result['status']['code'] != 1:boo=False
        return public.returnMsg(boo,result['status']['message'])

    #修改记录
    def up_jl(self,args):
        url = "http://api.dnsdun.com/?c=record&a=modify"
        arr = {'format':'json','domain':args['title'],'api_key':self.api_key,'uid':self.api_uid,'lang':'cn','record_id':args['record_id'],'sub_domain':args['sub_domain'],'record_type':args['record_type'],'record_line':args['record_line'],'value':args['value']}
        result=public.HttpPost(url,arr)
        result=json.loads(result)
        boo=True
        if result['status']['code'] != 1:boo=False
        return public.returnMsg(boo,result['status']['message'])
    
    #记录列表
    def list_jl(self,args):
        url = "http://api.dnsdun.com/?c=record&a=list"
        arr = {'format':'json','domain':args['title'],'api_key':self.api_key,'uid':self.api_uid,'lang':'cn'}
        result=public.HttpPost(url,arr)
        result=json.loads(result)
        if result['status']['code'] != '1' : return public.returnMsg(False,result['status']['message'])
        return dict(result)
    
    #记录信息
    def info_jl(self,args):
        url = "http://api.dnsdun.com/?c=record&a=info"
        arr = {'format':'json','domain':args['title'],'api_key':self.api_key,'uid':self.api_uid,'lang':'cn','record_id':args['record_id']}
        result=public.HttpPost(url,arr)
        return json.loads(result)['record']
